<script setup lang="ts">
    import { Article } from '@/logisticServiceOffer/entities/article/Article'
    import { computed, ref } from 'vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { CreateMouvementDto } from '../entities/mouvement/CreateMouvementDto'
    import { useDisplay } from 'vuetify'
    import { emitSnackBar } from '@/plugins/snackBarManager'

    // Destructure only the keys you want to use
    const { mdAndUp } = useDisplay()
    interface Props {
        isProcessing: boolean
        article: Article
        lotInitial: Article['lots'][number]
        typeDeMouvementId: string
        submitLabel?: string
    }

    const quantité = ref<number>()
    const props = withDefaults(defineProps<Props>(), {
        isProcessing: false,
        submitLabel: () => {
            return 'Mettre à jour'
        },
    })

    const emit =
        defineEmits<
            (e: 'submit', CreateMouvementDto: CreateMouvementDto) => void
        >()

    const deltaQuantité = computed(() => {
        if (quantité.value === undefined) {
            return undefined
        }
        const delta = quantité.value - props.lotInitial.quantité
        if (delta === 0) {
            return undefined
        }
        const sign = delta > 0 ? '+' : '-'

        return `${sign}${Math.abs(delta)} ${props.article.unité.toLowerCase()}`
    })
    function generateCreateMouvementDto(
        quantitéRelevée: number
    ): CreateMouvementDto {
        return {
            quantité: quantitéRelevée - props.lotInitial.quantité,
            article: {
                id: props.article.id,
            },
            emplacement: props.lotInitial.emplacement,
            typeDeMouvement: {
                id: props.typeDeMouvementId,
            },
        }
    }
</script>

<template>
    <div>
        <div class="d-flex align-end">
            <v-card-title data-cy="emplacement-article" class="pb-0 pr-1">
                {{ lotInitial.emplacement?.code ?? '(sans emplacement)' }}
            </v-card-title>
            <v-card-subtitle
                class="text-grey-darken-1 pl-0 pb-1"
                data-cy="quantité-article"
            >
                (en stock :
                <strong data-cy="quantite-initiale">{{
                    lotInitial.quantité
                }}</strong>
                <span class="text-lowercase"> {{ ' ' + article.unité }})</span>
            </v-card-subtitle>
        </div>

        <div class="d-flex">
            <v-card-text>
                <v-text-field
                    v-model.number="quantité"
                    type="number"
                    style="min-width: 15em"
                    label="Relevé"
                    data-cy="valeur-stock-relevee"
                    :suffix="article.unité.toLowerCase()"
                    :autofocus="article.lots.length === 1"
                    :hint="deltaQuantité"
                    hide-details="auto"
                    @keydown.enter.exact.prevent="
                        emitSnackBar(
                            'Utilisez &quot;Ctrl+Entrée&quot; ou cliquez sur le bouton pour valider la quantité. Cette sécurité est en place pour éviter toute saisie involontaire avec les lecteurs de codes-barres.',
                            'info'
                        )
                    "
                    @keydown.ctrl.enter.exact.prevent="
                        () => {
                            if (typeof quantité === 'number') {
                                emit(
                                    'submit',
                                    generateCreateMouvementDto(quantité)
                                )
                            }
                        }
                    "
                >
                </v-text-field>
            </v-card-text>
            <v-btn
                v-if="mdAndUp"
                class="ma-4 ml-0"
                data-cy="btn-enregistrer-valeur-stock"
                :loading="isProcessing"
                size="x-large"
                :disabled="typeof quantité !== 'number'"
                @click="
                    () => {
                        if (typeof quantité === 'number') {
                            emit('submit', generateCreateMouvementDto(quantité))
                        }
                    }
                "
            >
                {{ submitLabel }}
            </v-btn>
        </div>

        <v-divider v-if="!mdAndUp"></v-divider>
        <v-card-actions v-if="!mdAndUp">
            <v-spacer></v-spacer>
            <s-action-button
                :loading="isProcessing"
                :disabled="typeof quantité !== 'number'"
                data-cy="btn-enregistrer-valeur-stock"
                size="x-large"
                @click="
                    () => {
                        if (typeof quantité === 'number') {
                            emit('submit', generateCreateMouvementDto(quantité))
                        }
                    }
                "
            >
                {{ submitLabel }}
            </s-action-button>
        </v-card-actions>
    </div>
</template>
